#if _IBMR2
#include <stdio.h>
#include <strings.h>

/***********************************************************************
_getenv(ename) is equivalent to C's getenv(), but has a different name
to deal with those systems that use the same names in C and Fortran.
[13-Feb-1991]
***********************************************************************/

extern char **environ;

char *
_getenv(name)
char *name;
{
    int envvar_length;
    int k;
    int name_length;
    char *p;

    name_length = strlen(name);

    for (k = 0; environ[k]; ++k)
    {
	p = strchr(environ[k],'=');
	if (p != (char*)NULL)
	{
	    envvar_length = p - environ[k];
	    if ((envvar_length == name_length) &&
		(strncmp(environ[k],name,envvar_length) == 0))
	        return (p + 1);
	}
    }
    return ((char*)NULL);
}
#endif /* _IBMR2 */

#ifdef _AIX370

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>

/***********************************************************************
getenv_(ename) is equivalent to C's getenv(), with BSD Fortran 
calling conventions.
[15-Aug-1991]
***********************************************************************/

void
getenv_(name, value, plen_name, plen_value)
char *name;
char *value;
int *plen_name;
int *plen_value;
{
    int k;
    char *p;
    char *q;
    int c;

    for (p = &name[*plen_name-1]; (p > name) && (*p == ' '); --p)
	/* NO-OP */;			/* trim trailing blanks */

    c = p[1];
    p[1] = '\0';			/* supply NUL terminator */
    q = getenv(name);			/* get the value */
    p[1] = c;				/* restore the last character */

    for (k = 0; k < *plen_value; ++k)
	value[k] = ' ';			/* fill value with blanks */

    if (q != (char*)NULL)
    {
	for (k = 0; *q && (k < *plen_value); ++k, ++q)
	    value[k] = *q;		/* copy in the value */
    }
}
#endif /* _AIX370 */
