C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.9 [16-Apr-1992]
C-fpp- Date: Fri Oct 22 14:28:08 1993
C-fpp- Directory: /usr/local/plot79/prim
C-fpp- User: Nelson H. F. Beebe <beebe@solitude.math.utah.edu>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _BSD=1
C-fpp- Macro: _SUN=1
C-fpp- Macro: _SUN4=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- Macro: _IEEE_754=1
C-fpp- Macro: _NAMELIST=1
C-fpp- =================================================================
      SUBROUTINE  TKIOCL
C     (Close)
C     Close the files NPLOT and NHARD (if it is open) and return
C     the unit numbers to the system for reassignment.  On return,
C     both unit numbers are 0.
C     (31-Dec-1990)
      INCLUDE 'tkio02.inc'
      INCLUDE 'tkio03.inc'
C#if !_BSD
C##      INTEGER IOSTAT, XCLOSE
C#endif
C
C     Send an ASCII CAN (CTL-X) as the last byte; this puts a VT640 back
C     into VT100 mode from Tektronix mode, and hopefully will not cause
C     serious problems on any other terminal.
C
C     CALL TKIOWB (24)
      CALL TKIOMC
C#if _BSD
      CLOSE (UNIT=NPLOT)
C#else
C##      IOSTAT = XCLOSE(NPLOT)
C#endif
      NPLOT = 0
      IF (NHARD .NE. 0) THEN
C#if _BSD
      CLOSE (UNIT=NHARD)
C#else
C##      IOSTAT = XCLOSE(NHARD)
C#endif
           NHARD = 0
      END IF
C
      RETURN
      END
      SUBROUTINE  TKIOEC (ONECHO)
C     (On Echo)
C     Turn full-duplex echoing of characters on (ONECHO = .TRUE.)
C     or off (ONECHO = .FALSE.) for file NPLOT.  This can be used
C     to allow keyboard input while preventing the normal echo
C     from overwriting a plot on the screen.
C     (05-Feb-82)
      LOGICAL ONECHO
C
      RETURN
      END
      SUBROUTINE  TKIOGU (NUNIT)
C     (Get Unit)
C     Return the number of the next available FORTRAN unit.
C     (21-OCT-1993)
      INTEGER    NUNIT
C
C     The PLOT79 FNTFIL uses unit 19 in SYM00 on Unix and only
C     1..4 and 7..19 are available for assignment.
C
C#if _BSD
      LOGICAL    ISOPEN
      NUNIT = 18
   10 INQUIRE (UNIT=NUNIT,OPENED=ISOPEN)
      IF (ISOPEN) THEN
           NUNIT = NUNIT - 1
           IF (NUNIT .GT. 6) GO TO 10
           IF ((NUNIT .EQ. 5) .OR. (NUNIT .EQ. 6)) NUNIT = 4
           IF (NUNIT .GT. 0) GO TO 10
      END IF
C#else
C##      INTEGER   XUNIT
C##      NUNIT = XUNIT()
C#endif
C
      RETURN
      END
      INTEGER FUNCTION  TKIOLL (DUMMY)
C     (Line Length)
C     Return the current output line length.
C     (04-MAY-89)
      INTEGER         DUMMY
C
      INCLUDE 'tkio05.inc'
C
      TKIOLL = LINELN
C
      RETURN
      END
      SUBROUTINE  TKIOMC
C     (Make Current)
C     Empty the buffers for the files NPLOT and NHARD (if it is
C     open) so that the plot is up to date on the screen and/or
C     hardcopy device.
C     (17-May-83)
      INCLUDE 'tkio02.inc'
      INCLUDE 'tkio03.inc'
C
      IF (NXTCRT .GT. 1) CALL TKIOPB (NPLOT,BUFCRT,NXTCRT-1)
      NXTCRT = 1
      IF ((NHARD .NE. 0) .AND. (NXTHRD .GT. 1))
     X     CALL TKIOPB (NHARD,BUFHRD,NXTHRD-1)
      NXTHRD = 1
C
      RETURN
      END
      SUBROUTINE  TKIONG (FILNAM)
C     (New Generation)
C     Before  opening,  and  possibly overwriting, FILNAM,  check
C     that the file does not already exist.   If  it  does,  then
C     strip  any   numeric  generation  number of the form ".nnn"
C     (where the number is one or more digits), or initialize the
C     generation number to 0, and then attach successively higher
C     generation numbers until a filename is found which does not
C     exist.   This should successfully mimic a DEC TOPS-20 / VMS
C     / RSX / RSTS file generation number on Unix.
C
C     File names beginning "/dev/" are recognized as special, and
C     left intact.
C     (21-OCT-1993)
      CHARACTER*(*) FILNAM
      CHARACTER*10  FMT
      LOGICAL       ISFILE
      INTEGER       I,K,L,GEN,INDEX,LEN
C#if _MIPS
C##      INTEGER       IOS
C#endif
C
      K = LEN(FILNAM)
      GEN = 0
      IF (K .LT. 5) GO TO 10
      IF (FILNAM(1:5) .EQ. '/dev/') RETURN
   10 I = INDEX('0123456789 ',FILNAM(K:K)) - 1
      IF (I .LT. 0) GO TO 20
      IF (I .LE. 9) GEN = 10*GEN + I
      K = K - 1
      IF (K .GT. 1) GO TO 10
C
C     The entire name consists of blanks and or digits, except for
C     possibly the first character which we have not examined.  To
C     this stem will be appended the generation number.
C
      K = 1
C
C     FILNAM(K:K) is neither a blank nor a digit.  If it is a period
C     then we save it, and otherwise we append a period.
C
   20 IF (FILNAM(K:K) .NE. '.') THEN
           K = K + 1
           FILNAM(K:K) = '.'
      END IF
C
C     Now determine how many digits we need for the FORMAT item
C     which attaches the new generation number to the filename.
C     We return here until a unique filename is finally created.
C
   30 GEN = GEN + 1
      I = GEN
      L = 0
   40 I = I/10
      L = L + 1
      IF (I .GT. 0) GO TO 40
C
C     Now make an "Iw.w" format, append the generation number
C     to the filename, and then ask whether the file exists.
C
      FMT = ' '
      WRITE (FMT,'(''(I'',I2.2,''.'',I2.2,'')'')') L,L
      FILNAM(K+1:) = ' '
      WRITE (FILNAM(K+1:),FMT) GEN
C#if _MIPS
C##C
C##C     On MIPS RISCos 2.1.1, INQUIRE is unreliable, but OPEN can
C##C     equally well test for an existing file.  We use a large unit
C##C     number to avoid collisions with other software.
C##C
C##      OPEN (UNIT=199,FILE=FILNAM,IOSTAT=IOS,STATUS='old')
C##      IF (IOS .EQ. 0) THEN
C##           CLOSE (UNIT=199)
C##           ISFILE = .TRUE.
C##      ELSE
C##           ISFILE = .FALSE.
C##      END IF
C#else
      INQUIRE (FILE=FILNAM,EXIST=ISFILE)
C#endif
      IF (ISFILE) GO TO 30
C
      RETURN
      END
      SUBROUTINE  TKIOOP
C     (Open)
C     Open the plot file, NPLOT, on logical device CRT:.  If the
C     logical device HARDCOPY: is defined, open a hardcopy file,
C     NHARD, to it.  Otherwise NHARD is set to 0, indicating that
C     no hardcopy file is required.  System service routines are
C     used to obtain unique unit numbers for NPLOT and NHARD,
C     preventing possible conflicts with user-assigned unit numbers
C     elsewhere.  The files are opened with CARRIAGECONTROL='NONE'
C     which permits BYTE data to be written under A1 FORMAT items.
C     Experiments have verified that this allows reading and writing
C     of all 256 8-bit bytes.
C     (14-Feb-1992)
      CHARACTER*63 FILNAM
      INTEGER NTTY
C#if  _BSD
      LOGICAL ISATTY
C#else
C##      CHARACTER*2      MODE
C##      INTEGER          XISTTY
C##      INTEGER          IOSTAT,      XOPEN
C#endif
      INCLUDE 'tkio02.inc'
      INCLUDE 'tkio03.inc'
      INCLUDE 'tkio05.inc'
C
C#if  _HPUX
C##      DATA            NTTY /7/
C#else
      DATA            NTTY /0/
C#endif
C
      CALL P79ENV ('PLOTFILE',FILNAM)
      IF (FILNAM .EQ. ' ') CALL P79ENV ('CRT',FILNAM)
      IF (FILNAM .EQ. ' ') THEN
           WRITE (NTTY,1000)
           FILNAM = 'CRT'
      END IF
      CALL TKIOGU (NPLOT)
      CALL TKIONG (FILNAM)
C#if  _BSD
      OPEN (UNIT=NPLOT,FILE=FILNAM,STATUS='UNKNOWN')
      ISTERM = ISATTY(NPLOT)
C#else
C##      MODE = 'w'
C##      IOSTAT = XOPEN(NPLOT,FILNAM,MODE)
C##      ISTERM = (XISTTY(NPLOT) .EQ. 0)
C#endif
C
      CALL P79ENV ('HARDCOPY',FILNAM)
      IF (FILNAM .NE. ' ') THEN
           CALL TKIOGU (NHARD)
           CALL TKIONG (FILNAM)
C#if  _BSD
           OPEN (UNIT=NHARD,FILE=FILNAM,STATUS='UNKNOWN')
C#else
C##      MODE = 'w'
C##      IOSTAT = XOPEN(NHARD,FILNAM,MODE)
C#endif
      ELSE
           NHARD = 0
      END IF
C
C     Finally, initialize the output buffers to empty.  The buffer
C     sizes can be set differently if desired; perhaps a small buffer
C     is best for CRT and a large one for the Hardcopy device.
C
      NXTCRT = 1
      NXTHRD = 1
      LINELN = 0
C
      RETURN
C
 1000 FORMAT ('%TKIOOP:  Logical name or UNIX environment variable'/
     X        'PLOTFILE (or CRT) was not defined.'/
     X        'The plot will be written to the file CRT.nnn.')
      END
      SUBROUTINE  TKIOPB (NUNIT,BYTES,NBYTES)
C     (Put Buffer)
C     Output a buffer of NBYTES bytes to unit NUNIT.
C     (01-Mar-1991)
      INTEGER        NBYTES,       NUNIT
C#if _GOULD
C##      CHARACTER*1    BYTES(4,NBYTES)
C#else
      INTEGER        BYTES(NBYTES)
C#endif
      INTEGER        I,           K
      CHARACTER      CHAR
C#if _BSD
      INTEGER        FPUTC
C#else
C##      INTEGER        XPUTC
C#endif
C
C     WRITE (NUNIT,1000) BYTES
C
      DO 10 K = 1,NBYTES
C#if _BSD
C#if _GOULD
C##      CALL FPUTC(NUNIT,CHAR(BYTES(4,K)))
C#else
           I = FPUTC(NUNIT,CHAR(BYTES(K)))
C#endif
C#else
C##           I = XPUTC(NUNIT,CHAR(BYTES(K)))
C#endif
   10 CONTINUE
C
C#if _BSD
      CALL FLUSH (NUNIT)
C#else
C##      CALL XFLUSH (NUNIT)
C#endif
C
      RETURN
C 1000 FORMAT ($,512A1)
      END
      SUBROUTINE  TKIORS (BYTES,NBYTES)
C     (Read String)
C     Read and return exactly NBYTES bytes from the file NPLOT.  If
C     the file is not directed to a terminal, BYTES(*) is filled
C     with zero bytes.
C     (05-Feb-82)
      INTEGER BYTES(1)
      INTEGER NBYTES,I
      INCLUDE 'tkio02.inc'
C
      IF (ISTERM) THEN
           READ (NPLOT,1000) (BYTES(I), I = 1,NBYTES)
      ELSE
           DO 10 I = 1,NBYTES
           BYTES(I) = 0
   10      CONTINUE
      END IF
C
      RETURN
 1000 FORMAT (128A1)
      END
      LOGICAL FUNCTION  TKIOTT (DUMMY)
C     (Is Terminal?)
C     Return .TRUE. if the plot file is directed to a terminal, and
C     .FALSE. otherwise.
C     (05-Feb-82)
      INTEGER DUMMY
      INCLUDE 'tkio02.inc'
C
      TKIOTT = ISTERM
C
      RETURN
      END
      SUBROUTINE  TKIOWB (ABYTE)
C     (Write Byte)
C     Write a single byte to the plot file and possibly hardcopy file.
C     (04-MAY-89)
      INTEGER ABYTE
      INCLUDE 'tkio02.inc'
      INCLUDE 'tkio03.inc'
      INCLUDE 'tkio05.inc'
C
      IF (NXTCRT .GT. MAXCRT) THEN
           CALL TKIOPB (NPLOT,BUFCRT,NXTCRT-1)
           NXTCRT = 1
      END IF
      BUFCRT(NXTCRT) = ABYTE
      NXTCRT = NXTCRT + 1
      IF (NHARD .NE. 0) THEN
           IF (NXTHRD .GT. MAXHRD) THEN
                CALL TKIOPB (NHARD,BUFHRD,NXTHRD-1)
                NXTHRD = 1
           END IF
           BUFHRD(NXTHRD) = ABYTE
           NXTHRD = NXTHRD + 1
      END IF
C
      IF (ABYTE .EQ. 10) THEN
           LINELN = 0
      ELSE
           LINELN = LINELN + 1
      END IF
C
      RETURN
      END
      SUBROUTINE  TKIOWF (ABYTE,NTIMES)
C     (Write Filler Byte)
C     Send the byte ABYTE to the plot file NTIMES.
C     (05-Feb-82)
      INTEGER ABYTE
      INTEGER NTIMES,I
C
           DO 10 I = 1,NTIMES
           CALL TKIOWB (ABYTE)
   10      CONTINUE
C
      RETURN
      END
      SUBROUTINE  TKIOWH (TEXT,LENTXT)
C     (Write Hollerith)
C     Output an  nn-character Hollerith  string  as a  string  of
C     ASCII characters.   The  string  may contain  one  or  more
C     escape sequences of the form
C
C     string            result
C     $E or $e          <ESC>
C     $B or $b          <BS>
C     $T or $t          <HT> (tab)
C     $F or $f          <FF>
C     $N or $n          <LF>
C     $R or $r          <CR>
C     $$                <$>
C     $<other>          <other>
C     $n                <n>
C     $nn               <nn>
C     $nnn              <nnn>
C
C     For the last three,  a 1-, 2-, or  3-OCTAL digit string  is
C     converted to a number and  the ASCII character having  that
C     value is output.
C     (28-JUL-84)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       KARASC,      KARGET,      TKIOWB
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             KARASC
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                ASCII,       ESCPFX,      K,           NUMBER
C     SETS                X
C
      INTEGER             ASCII,       C,           ESCPFX,      K
      INTEGER             LENTXT,      NUMBER,      TEXT(1),     X(128)
C
      DATA X(  1), X(  2), X(  3), X(  4) /   0,  1,  2,  3 /
      DATA X(  5), X(  6), X(  7), X(  8) /   4,  5,  6,  7 /
      DATA X(  9), X( 10), X( 11), X( 12) /   8,  9, 10, 11 /
      DATA X( 13), X( 14), X( 15), X( 16) /  12, 13, 14, 15 /
      DATA X( 17), X( 18), X( 19), X( 20) /  16, 17, 18, 19 /
      DATA X( 21), X( 22), X( 23), X( 24) /  20, 21, 22, 23 /
      DATA X( 25), X( 26), X( 27), X( 28) /  24, 25, 26, 27 /
      DATA X( 29), X( 30), X( 31), X( 32) /  28, 29, 30, 31 /
      DATA X( 33), X( 34), X( 35), X( 36) /  32, 33, 34, 35 /
      DATA X( 37), X( 38), X( 39), X( 40) /  36, 37, 38, 39 /
      DATA X( 41), X( 42), X( 43), X( 44) /  40, 41, 42, 43 /
      DATA X( 45), X( 46), X( 47), X( 48) /  44, 45, 46, 47 /
      DATA X( 49), X( 50), X( 51), X( 52) / -48,-49,-50,-51 /
      DATA X( 53), X( 54), X( 55), X( 56) / -52,-53,-54,-55 /
      DATA X( 57), X( 58), X( 59), X( 60) /  56, 57, 58, 59 /
      DATA X( 61), X( 62), X( 63), X( 64) /  60, 61, 62, 63 /
      DATA X( 65), X( 66), X( 67), X( 68) /  64, 65,  8, 67 /
      DATA X( 69), X( 70), X( 71), X( 72) /  68, 27, 12, 71 /
      DATA X( 73), X( 74), X( 75), X( 76) /  72, 73, 74, 75 /
      DATA X( 77), X( 78), X( 79), X( 80) /  76, 77, 10, 79 /
      DATA X( 81), X( 82), X( 83), X( 84) /  80, 81, 13, 83 /
      DATA X( 85), X( 86), X( 87), X( 88) /   9, 85, 86, 87 /
      DATA X( 89), X( 90), X( 91), X( 92) /  88, 89, 90, 91 /
      DATA X( 93), X( 94), X( 95), X( 96) /  92, 93, 94, 95 /
      DATA X( 97), X( 98), X( 99), X(100) /  96, 97,  8, 99 /
      DATA X(101), X(102), X(103), X(104) / 100, 27, 12,103 /
      DATA X(105), X(106), X(107), X(108) / 104,105,106,107 /
      DATA X(109), X(110), X(111), X(112) / 108,109, 10,111 /
      DATA X(113), X(114), X(115), X(116) / 112,113, 13,115 /
      DATA X(117), X(118), X(119), X(120) /   9,117,118,119 /
      DATA X(121), X(122), X(123), X(124) / 120,121,122,123 /
      DATA X(125), X(126), X(127), X(128) / 124,125,126,127 /
C
      DATA                ESCPFX    / 36 /
C
      K = 0
   10 K = K + 1
      IF (K .GT. LENTXT) GO TO 50
      CALL KARGET (C,TEXT,K)
      ASCII = KARASC(C)
      IF (ASCII .NE. ESCPFX) GO TO 40
C
C     <ESCPFX><char>
C
      K = K + 1
      IF (K .GT. LENTXT) GO TO 50
      CALL KARGET (C,TEXT,K)
      ASCII = KARASC(C)
      ASCII = X(ASCII+1)
C
C     For non-negative entries, the translation is done.
C
      IF (ASCII .GE. 0) GO TO 40
C
C     <ESCPFX><octal digit>
C
      NUMBER = -48 - ASCII
      K = K + 1
      IF (K .GT. LENTXT) GO TO 30
      CALL KARGET (C,TEXT,K)
      ASCII = KARASC(C)
      ASCII = X(ASCII+1)
      IF (ASCII .GE. 0) GO TO 20
C
C     <ESCPFX><octal digit><octal digit>
C
      NUMBER = NUMBER*8 - 48 - ASCII
      K = K + 1
      IF (K .GT. LENTXT) GO TO 30
      CALL KARGET (C,TEXT,K)
      ASCII = KARASC(C)
      ASCII = X(ASCII+1)
      IF (ASCII .GE. 0) GO TO 20
C
C     <ESCPFX><octal digit><octal digit><octal digit>
C
      NUMBER = NUMBER*8 - 48 - ASCII
      GO TO 30
   20 K = K - 1
   30 ASCII = NUMBER
   40 CALL TKIOWB (ASCII)
      GO TO 10
C
   50 RETURN
      END
      SUBROUTINE  TKIOWN (NUMBER)
C     (Write Number)
C     Send the integer NUMBER to the plot files as an ASCII digit
C     string, suppressing leading blanks  and zeroes (except  for
C     the last digit).
C     (29-SEP-82)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       IABS,        MOD,         TKIOWB
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             IABS,        MOD
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                DIGITS,      MINUS,       N,           NBACK
C     SETS                NDIGIT,      NUMABS
C
      INTEGER             DIGITS(32),  MINUS,       N,           NBACK
      INTEGER             NDIGIT,      NUMABS,      NUMBER
C
      DATA    MINUS / 45 /
C
      NDIGIT = 0
      NUMABS = IABS(NUMBER)
C
C     Extract digits in reverse order (right to left).
C
   10 NDIGIT = NDIGIT + 1
      DIGITS(NDIGIT) = 48 + MOD(NUMABS,10)
      NUMABS = NUMABS/10
      IF (NUMABS .GT. 0) GO TO 10
C
      IF (NUMBER .LT. 0) CALL TKIOWB (MINUS)
           DO 20 NBACK = 1,NDIGIT
           N = NDIGIT + 1 - NBACK
           CALL TKIOWB (DIGITS(N))
   20      CONTINUE
C
      RETURN
      END
      SUBROUTINE  TKIOWS (BYTES,NBYTES)
C     (Write Byte String)
C     Write NBYTES bytes from BYTES(*) to the plot file.
C     (09-Jan-1991)
      INTEGER          BYTES(1),    I,           NBYTES
C
           DO 10 I = 1,NBYTES
           CALL TKIOWB (BYTES(I))
   10      CONTINUE
C
      RETURN
      END
      SUBROUTINE  TKIOWT (MSECS)
C     (Wait)
C     Cause a real-time delay of MSECS milliseconds before returning.
C     This is done by transmitting NUL's to the plot file, rather
C     that actually suspending the process.  That way, if the plot file
C     is actually in a disk file, a later COPY to a graphics terminal
C     will still result in a delay.
C     (05-Feb-82)
      INTEGER NUL
      INTEGER MSECS,CHARPS
C
C     CHARPS.......Terminal transmission rate in characters/second
C
C$ux  DATA NUL    /0/
C     For Unix, f77 will not write an ASCII NUL on an A1 format,
C     so we output a NUL with the high bit on, which does get
C     correctly written.
C
      DATA NUL    / 22/
      DATA CHARPS /960/
C
      CALL TKIOWF (NUL,MAX0(1,(MSECS*CHARPS)/1000))
C
      RETURN
      END
      SUBROUTINE  TKIOIF (NUNIT, FNAME, MAXFNM)
C     (Inquire Filename)
C     Return in FNAME a packed Hollerith string containing
C     the name of the file open on unit NUNIT, or blank if
C     the name is unavailable.
C     (09-Jan-1991)
      INTEGER             FNAME(1),    K,           MAXFNM,      NUNIT
      CHARACTER*255       CFNAME
C#if !_BSD
C##      INTEGER             XFNAME
C#endif
C
      DO 10 K = 1,MAXFNM
           CALL KARPUT (1H ,FNAME,K)
   10 CONTINUE
C#if _BSD
      INQUIRE (UNIT=NUNIT, NAME=CFNAME)
C#else
C##      K = XFNAME (NUNIT, CFNAME)
C#endif
      CALL CHRCTH (FNAME,1,MIN0(LEN(CFNAME),MAXFNM),CFNAME)
C
      RETURN
      END
